/[gentoo-x86]/eclass/kde4-base.eclass
Gentoo

Diff of /eclass/kde4-base.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.53 Revision 1.99
1# Copyright 1999-2009 Gentoo Foundation 1# Copyright 1999-2010 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/kde4-base.eclass,v 1.53 2009/11/25 19:51:11 tampakrap Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/kde4-base.eclass,v 1.99 2011/06/15 00:11:05 abcd Exp $
4 4
5# @ECLASS: kde4-base.eclass 5# @ECLASS: kde4-base.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# kde@gentoo.org 7# kde@gentoo.org
8# @BLURB: This eclass provides functions for kde 4.X ebuilds 8# @BLURB: This eclass provides functions for kde 4.X ebuilds
9# @DESCRIPTION: 9# @DESCRIPTION:
10# The kde4-base.eclass provides support for building KDE4 based ebuilds 10# The kde4-base.eclass provides support for building KDE4 based ebuilds
11# and KDE4 applications. 11# and KDE4 applications.
12# 12#
13# NOTE: KDE 4 ebuilds by default define EAPI="2", this can be redefined but 13# NOTE: KDE 4 ebuilds currently support EAPI "3". This will be reviewed
14# eclass will fail with version older than 2. 14# over time as new EAPI versions are approved.
15
16# @ECLASS-VARIABLE: VIRTUALX_REQUIRED
17# @DESCRIPTION:
18# For proper description see virtualx.eclass manpage.
19# Here we redefine default value to be manual, if your package needs virtualx
20# for tests you should proceed with setting VIRTUALX_REQUIRED=test.
21: ${VIRTUALX_REQUIRED:=manual}
22
23inherit kde4-functions toolchain-funcs fdo-mime gnome2-utils base virtualx versionator eutils
24
25if [[ ${BUILD_TYPE} = live ]]; then
26 case ${KDE_SCM} in
27 svn) inherit subversion ;;
28 git) inherit git-2 ;;
29 esac
30fi
15 31
16# @ECLASS-VARIABLE: CMAKE_REQUIRED 32# @ECLASS-VARIABLE: CMAKE_REQUIRED
17# @DESCRIPTION: 33# @DESCRIPTION:
18# Specify if cmake buildsystem is being used. Possible values are 'always' and 'never'. 34# Specify if cmake buildsystem is being used. Possible values are 'always' and 'never'.
19# Please note that if it's set to 'never' you need to explicitly override following phases: 35# Please note that if it's set to 'never' you need to explicitly override following phases:
20# src_configure, src_compile, src_test and src_install. 36# src_configure, src_compile, src_test and src_install.
21# Defaults to 'always'. 37# Defaults to 'always'.
22CMAKE_REQUIRED="${CMAKE_REQUIRED:-${CMAKE_REQUIRED:-always}}" 38: ${CMAKE_REQUIRED:=always}
23if [[ ${CMAKE_REQUIRED} = false || ${CMAKE_REQUIRED} = never ]]; then 39if [[ ${CMAKE_REQUIRED} = always ]]; then
24 buildsystem_eclass=""
25 export_fns=""
26else
27 buildsystem_eclass="cmake-utils" 40 buildsystem_eclass="cmake-utils"
28 export_fns="src_configure src_compile src_test src_install" 41 export_fns="src_configure src_compile src_test src_install"
29fi 42fi
30 43
31inherit kde4-functions 44# @ECLASS-VARIABLE: KDE_MINIMAL
45# @DESCRIPTION:
46# This variable is used when KDE_REQUIRED is set, to specify required KDE minimal
47# version for apps to work. Currently defaults to 4.4
48# One may override this variable to raise version requirements.
49# Note that it is fixed to ${PV} for kde-base packages.
50KDE_MINIMAL="${KDE_MINIMAL:-4.4}"
32 51
33get_build_type 52# Set slot for KDEBASE known packages
53case ${KDEBASE} in
54 kde-base)
55 SLOT=$(get_kde_version)
56 [[ -z ${SLOT} ]] && die "Unsupported PV ${PV}"
57 KDE_MINIMAL="${PV}"
58 ;;
59 koffice)
60 SLOT="2"
61 ;;
62 kdevelop)
34if [[ ${BUILD_TYPE} = live ]]; then 63 if [[ ${BUILD_TYPE} = live ]]; then
35 subversion_eclass="subversion" 64 # @ECLASS-VARIABLE: KDEVELOP_VERSION
36fi 65 # @DESCRIPTION:
66 # Specifies KDevelop version. Default is 4.0.0 for tagged packages and 9999 for live packages.
67 # Applies to KDEBASE=kdevelop only.
68 KDEVELOP_VERSION="${KDEVELOP_VERSION:-9999}"
69 # @ECLASS-VARIABLE: KDEVPLATFORM_VERSION
70 # @DESCRIPTION:
71 # Specifies KDevplatform version. Default is 1.0.0 for tagged packages and 9999 for live packages.
72 # Applies to KDEBASE=kdevelop only.
73 KDEVPLATFORM_VERSION="${KDEVPLATFORM_VERSION:-9999}"
74 else
75 case ${PN} in
76 kdevelop|quanta)
77 KDEVELOP_VERSION=${PV}
78 KDEVPLATFORM_VERSION="$(($(get_major_version)-3)).$(get_after_major_version)"
79 ;;
80 kdevplatform)
81 KDEVELOP_VERSION="$(($(get_major_version)+3)).$(get_after_major_version)"
82 KDEVPLATFORM_VERSION=${PV}
83 ;;
84 *)
85 KDEVELOP_VERSION="${KDEVELOP_VERSION:-4.0.0}"
86 KDEVPLATFORM_VERSION="${KDEVPLATFORM_VERSION:-1.0.0}"
87 esac
88 fi
89 SLOT="4"
90 ;;
91esac
37 92
38inherit base ${buildsystem_eclass} eutils ${subversion_eclass} 93inherit ${buildsystem_eclass}
39 94
40EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare ${export_fns} pkg_postinst pkg_postrm 95EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare ${export_fns} pkg_preinst pkg_postinst pkg_postrm
41 96
42unset buildsystem_eclass 97unset buildsystem_eclass
43unset export_fns 98unset export_fns
44unset subversion_eclass
45 99
100# @ECLASS-VARIABLE: DECLARATIVE_REQUIRED
101# @DESCRIPTION:
102# Is qt-declarative required? Possible values are 'always', 'optional' and 'never'.
103# This variable must be set before inheriting any eclasses. Defaults to 'never'.
104DECLARATIVE_REQUIRED="${DECLARATIVE_REQUIRED:-never}"
105
106# @ECLASS-VARIABLE: QTHELP_REQUIRED
107# @DESCRIPTION:
108# Is qt-assistant required? Possible values are 'always', 'optional' and 'never'.
109# This variable must be set before inheriting any eclasses. Defaults to 'never'.
110QTHELP_REQUIRED="${QTHELP_REQUIRED:-never}"
111
112# @ECLASS-VARIABLE: OPENGL_REQUIRED
113# @DESCRIPTION:
114# Is qt-opengl required? Possible values are 'always', 'optional' and 'never'.
115# This variable must be set before inheriting any eclasses. Defaults to 'never'.
116OPENGL_REQUIRED="${OPENGL_REQUIRED:-never}"
117
118# @ECLASS-VARIABLE: MULTIMEDIA_REQUIRED
119# @DESCRIPTION:
120# Is qt-multimedia required? Possible values are 'always', 'optional' and 'never'.
121# This variable must be set before inheriting any eclasses. Defaults to 'never'.
122MULTIMEDIA_REQUIRED="${MULTIMEDIA_REQUIRED:-never}"
123
124# @ECLASS-VARIABLE: CPPUNIT_REQUIRED
125# @DESCRIPTION:
126# Is cppunit required for tests? Possible values are 'always', 'optional' and 'never'.
127# This variable must be set before inheriting any eclasses. Defaults to 'never'.
128CPPUNIT_REQUIRED="${CPPUNIT_REQUIRED:-never}"
129
130# @ECLASS-VARIABLE: KDE_REQUIRED
131# @DESCRIPTION:
132# Is kde required? Possible values are 'always', 'optional' and 'never'.
133# This variable must be set before inheriting any eclasses. Defaults to 'always'
134# If set to 'always' or 'optional', KDE_MINIMAL may be overriden as well.
135# Note that for kde-base packages this variable is fixed to 'always'.
136KDE_REQUIRED="${KDE_REQUIRED:-always}"
137
138# @ECLASS-VARIABLE: KDE_HANDBOOK
139# @DESCRIPTION:
140# Set to enable handbook in application. Possible values are 'always', 'optional'
141# (handbook USE flag) and 'never'.
142# This variable must be set before inheriting any eclasses. Defaults to 'never'.
143# It adds default handbook dirs for kde-base packages to KMEXTRA and in any case it
144# ensures buildtime and runtime dependencies.
145KDE_HANDBOOK="${KDE_HANDBOOK:-never}"
146
147# @ECLASS-VARIABLE: KDE_LINGUAS_LIVE_OVERRIDE
148# @DESCRIPTION:
149# Set this varible if you want your live package to manage its
150# translations. (Mostly all kde ebuilds does not ship documentation
151# and translations in live ebuilds)
152if [[ ${BUILD_TYPE} == live && -z ${KDE_LINGUAS_LIVE_OVERRIDE} ]]; then
153 # Kdebase actualy provides the handbooks even for live stuff
154 [[ ${KDEBASE} == kde-base ]] || KDE_HANDBOOK=never
155 KDE_LINGUAS=""
156fi
157
158# Setup packages inheriting this eclass
46case ${KDEBASE} in 159case ${KDEBASE} in
47 kde-base) 160 kde-base)
48 HOMEPAGE="http://www.kde.org/" 161 HOMEPAGE="http://www.kde.org/"
49 LICENSE="GPL-2" 162 LICENSE="GPL-2"
50 ;;
51 koffice)
52 HOMEPAGE="http://www.koffice.org/"
53 LICENSE="GPL-2"
54 ;;
55esac
56
57# @ECLASS-VARIABLE: OPENGL_REQUIRED
58# @DESCRIPTION:
59# Is qt-opengl required? Possible values are 'always', 'optional' and 'never'.
60# This variable must be set before inheriting any eclasses. Defaults to 'never'.
61OPENGL_REQUIRED="${OPENGL_REQUIRED:-never}"
62
63# @ECLASS-VARIABLE: WEBKIT_REQUIRED
64# @DESCRIPTION:
65# Is qt-webkit requred? Possible values are 'always', 'optional' and 'never'.
66# This variable must be set before inheriting any eclasses. Defaults to 'never'.
67WEBKIT_REQUIRED="${WEBKIT_REQUIRED:-never}"
68
69# @ECLASS-VARIABLE: CPPUNIT_REQUIRED
70# @DESCRIPTION:
71# Is cppunit required for tests? Possible values are 'always', 'optional' and 'never'.
72# This variable must be set before inheriting any eclasses. Defaults to 'never'.
73CPPUNIT_REQUIRED="${CPPUNIT_REQUIRED:-never}"
74
75# @ECLASS-VARIABLE: KDE_REQUIRED
76# @DESCRIPTION:
77# Is kde required? Possible values are 'always', 'optional' and 'never'.
78# This variable must be set before inheriting any eclasses. Defaults to 'always'
79# If set to always or optional, KDE_MINIMAL may be overriden as well.
80# Note that for kde-base packages this variable is fixed to 'always'.
81KDE_REQUIRED="${KDE_REQUIRED:-always}"
82
83# Verify KDE_MINIMAL (display QA notice in pkg_setup, still we need to fix it here)
84if [[ -n ${KDE_MINIMAL} ]]; then
85 for slot in ${KDE_SLOTS[@]} ${KDE_LIVE_SLOTS[@]}; do
86 [[ ${KDE_MINIMAL} = ${slot} ]] && KDE_MINIMAL_VALID=1 && break
87 done
88 unset slot
89 [[ -z ${KDE_MINIMAL_VALID} ]] && unset KDE_MINIMAL
90else
91 KDE_MINIMAL_VALID=1
92fi
93
94# @ECLASS-VARIABLE: KDE_MINIMAL
95# @DESCRIPTION:
96# This variable is used when KDE_REQUIRED is set, to specify required KDE minimal
97# version for apps to work. Currently defaults to 4.3
98# One may override this variable to raise version requirements.
99# For possible values look at KDE_SLOTS and KDE_LIVE_SLOTS variables.
100# Note that it is fixed to ${SLOT} for kde-base packages.
101KDE_MINIMAL="${KDE_MINIMAL:-4.3}"
102
103# Setup packages inheriting this eclass
104case ${KDEBASE} in
105 kde-base)
106 if [[ $BUILD_TYPE = live ]]; then 163 if [[ $BUILD_TYPE = live ]]; then
107 # Disable tests for live ebuilds 164 # Disable tests for live ebuilds
108 RESTRICT+=" test" 165 RESTRICT+=" test"
109 # Live ebuilds in kde-base default to kdeprefix by default 166 fi
110 IUSE+=" +kdeprefix" 167
111 else 168 # Only add the kdeprefix USE flag for older versions, to help
112 # All other ebuild types default to -kdeprefix as before 169 # non-portage package managers handle the upgrade
170 if [[ ${PV} < 4.6.4 && ( ( ${KMNAME} != kdepim && ${PN} != kdepim-runtime ) || ${PV} < 4.6 ) ]]; then
113 IUSE+=" kdeprefix" 171 IUSE+=" kdeprefix"
114 fi 172 fi
115 # Determine SLOT from PVs 173
116 case ${PV} in
117 *.9999*) SLOT="${PV/.9999*/}" ;; # stable live
118 4.4* | 4.3.[6-9]*) SLOT="4.4" ;;
119 4.3*) SLOT="4.3" ;;
120 4.2*) SLOT="4.2" ;;
121 9999*) SLOT="live" ;; # regular live
122 *) die "Unsupported ${PV}" ;;
123 esac
124 # This code is to prevent portage from searching GENTOO_MIRRORS for 174 # This code is to prevent portage from searching GENTOO_MIRRORS for
125 # packages that will never be mirrored. (As they only will ever be in 175 # packages that will never be mirrored. (As they only will ever be in
126 # the overlay). 176 # the overlay).
127 case ${PV} in 177 case ${PV} in
128 *9999* | 4.?.[6-9]?) 178 *9999* | 4.?.[6-9]?)
129 RESTRICT+=" mirror" 179 RESTRICT+=" mirror"
130 ;; 180 ;;
131 esac 181 esac
132 KDE_MINIMAL="${SLOT}"
133 _kdedir="${SLOT}"
134
135 # Block installation of other SLOTS unless kdeprefix 182 # Block installation of other SLOTS unless kdeprefix
136 RDEPEND+=" $(block_other_slots)" 183 RDEPEND+=" $(block_other_slots)"
137 ;; 184 ;;
138 koffice) 185 koffice)
139 SLOT="2" 186 HOMEPAGE="http://www.koffice.org/"
187 LICENSE="GPL-2"
188 ;;
189 kdevelop)
190 HOMEPAGE="http://www.kdevelop.org/"
191 LICENSE="GPL-2"
140 ;; 192 ;;
141esac 193esac
142 194
143# @ECLASS-VARIABLE: QT_MINIMAL 195# @ECLASS-VARIABLE: QT_MINIMAL
144# @DESCRIPTION: 196# @DESCRIPTION:
145# Determine version of qt we enforce as minimal for the package. 4.4.0 4.5.1.. 197# Determine version of qt we enforce as minimal for the package.
146# Currently defaults to 4.5.1 for KDE 4.3 and earlier
147# or 4.6.0_beta for KDE 4.4 and later
148if slot_is_at_least 4.4 "${KDE_MINIMAL}"; then 198if version_is_at_least 4.5.50 "${KDE_MINIMAL}"; then
149 QT_MINIMAL="${QT_MINIMAL:-4.6.0_beta}" 199 QT_MINIMAL="${QT_MINIMAL:-4.7.0}"
200else
201 QT_MINIMAL="${QT_MINIMAL:-4.6.3}"
150fi 202fi
151 203
152QT_MINIMAL="${QT_MINIMAL:-4.5.1}" 204# Declarative dependencies
205qtdeclarativedepend="
206 >=x11-libs/qt-declarative-${QT_MINIMAL}:4
207"
208case ${DECLARATIVE_REQUIRED} in
209 always)
210 COMMONDEPEND+=" ${qtdeclarativedepend}"
211 ;;
212 optional)
213 IUSE+=" declarative"
214 COMMONDEPEND+=" declarative? ( ${qtdeclarativedepend} )"
215 ;;
216 *) ;;
217esac
218unset qtdeclarativedepend
219
220# QtHelp dependencies
221qthelpdepend="
222 >=x11-libs/qt-assistant-${QT_MINIMAL}:4
223"
224case ${QTHELP_REQUIRED} in
225 always)
226 COMMONDEPEND+=" ${qthelpdepend}"
227 ;;
228 optional)
229 IUSE+=" qthelp"
230 COMMONDEPEND+=" qthelp? ( ${qthelpdepend} )"
231 ;;
232esac
233unset qthelpdepend
153 234
154# OpenGL dependencies 235# OpenGL dependencies
155qtopengldepend=" 236qtopengldepend="
156 >=x11-libs/qt-opengl-${QT_MINIMAL}:4 237 >=x11-libs/qt-opengl-${QT_MINIMAL}:4
157" 238"
165 ;; 246 ;;
166 *) ;; 247 *) ;;
167esac 248esac
168unset qtopengldepend 249unset qtopengldepend
169 250
170# WebKit dependencies 251# MultiMedia dependencies
252qtmultimediadepend="
253 >=x11-libs/qt-multimedia-${QT_MINIMAL}:4
254"
171case ${KDE_REQUIRED} in 255case ${MULTIMEDIA_REQUIRED} in
172 always) 256 always)
173 qtwebkitusedeps="[kde]" 257 COMMONDEPEND+=" ${qtmultimediadepend}"
174 ;; 258 ;;
175 optional) 259 optional)
176 qtwebkitusedeps="[kde?]" 260 IUSE+=" multimedia"
261 COMMONDEPEND+=" multimedia? ( ${qtmultimediadepend} )"
177 ;; 262 ;;
178 *) ;; 263 *) ;;
179esac 264esac
180qtwebkitdepend=" 265unset qtmultimediadepend
181 >=x11-libs/qt-webkit-${QT_MINIMAL}:4${qtwebkitusedeps}
182"
183unset qtwebkitusedeps
184case ${WEBKIT_REQUIRED} in
185 always)
186 COMMONDEPEND+=" ${qtwebkitdepend}"
187 ;;
188 optional)
189 IUSE+=" webkit"
190 COMMONDEPEND+=" webkit? ( ${qtwebkitdepend} )"
191 ;;
192 *) ;;
193esac
194unset qtwebkitdepend
195 266
196# CppUnit dependencies 267# CppUnit dependencies
197cppuintdepend=" 268cppuintdepend="
198 dev-util/cppunit 269 dev-util/cppunit
199" 270"
207 ;; 278 ;;
208 *) ;; 279 *) ;;
209esac 280esac
210unset cppuintdepend 281unset cppuintdepend
211 282
283
284# WebKit use dependencies
285case ${KDE_REQUIRED} in
286 always)
287 qtwebkitusedeps="[kde]"
288 ;;
289 optional)
290 qtwebkitusedeps="[kde?]"
291 ;;
292 *) ;;
293esac
212# KDE dependencies 294# KDE dependencies
295# Qt accessibility classes are needed in various places, bug 325461
213kdecommondepend=" 296kdecommondepend="
214 dev-lang/perl 297 dev-lang/perl
215 >=x11-libs/qt-core-${QT_MINIMAL}:4[qt3support,ssl] 298 >=x11-libs/qt-core-${QT_MINIMAL}:4[qt3support,ssl]
216 >=x11-libs/qt-gui-${QT_MINIMAL}:4[accessibility,dbus] 299 >=x11-libs/qt-gui-${QT_MINIMAL}:4[accessibility,dbus]
217 >=x11-libs/qt-qt3support-${QT_MINIMAL}:4[accessibility,kde] 300 >=x11-libs/qt-qt3support-${QT_MINIMAL}:4[accessibility,kde]
218 >=x11-libs/qt-script-${QT_MINIMAL}:4 301 >=x11-libs/qt-script-${QT_MINIMAL}:4
219 >=x11-libs/qt-sql-${QT_MINIMAL}:4[qt3support] 302 >=x11-libs/qt-sql-${QT_MINIMAL}:4[qt3support]
220 >=x11-libs/qt-svg-${QT_MINIMAL}:4 303 >=x11-libs/qt-svg-${QT_MINIMAL}:4
221 >=x11-libs/qt-test-${QT_MINIMAL}:4 304 >=x11-libs/qt-test-${QT_MINIMAL}:4
305 >=x11-libs/qt-webkit-${QT_MINIMAL}:4${qtwebkitusedeps}
222 !aqua? ( 306 !aqua? (
223 x11-libs/libXext 307 x11-libs/libXext
224 x11-libs/libXt 308 x11-libs/libXt
225 x11-libs/libXxf86vm 309 x11-libs/libXxf86vm
310 x11-libs/libXcomposite
226 ) 311 )
227" 312"
313
228if [[ ${PN} != kdelibs ]]; then 314if [[ ${PN} != kdelibs ]]; then
229 if [[ ${KDEBASE} = kde-base ]]; then
230 kdecommondepend+=" $(add_kdebase_dep kdelibs)" 315 kdecommondepend+=" $(add_kdebase_dep kdelibs)"
231 # libknotificationitem only when SLOT is 4.3 316 if [[ ${KDEBASE} = kdevelop ]]; then
232 [[ ${PN} != libknotificationitem ]] && [[ ${SLOT} = 4.3 ]] && \ 317 if [[ ${PN} != kdevplatform ]]; then
233 kdecommondepend+=" $(add_kdebase_dep libknotificationitem)" 318 # @ECLASS-VARIABLE: KDEVPLATFORM_REQUIRED
234 else 319 # @DESCRIPTION:
320 # Specifies whether kdevplatform is required. Possible values are 'always' (default) and 'never'.
321 # Applies to KDEBASE=kdevelop only.
322 KDEVPLATFORM_REQUIRED="${KDEVPLATFORM_REQUIRED:-always}"
323 case ${KDEVPLATFORM_REQUIRED} in
324 always)
235 kdecommondepend+=" 325 kdecommondepend+="
236 >=kde-base/kdelibs-${KDE_MINIMAL} 326 >=dev-util/kdevplatform-${KDEVPLATFORM_VERSION}
327 "
328 ;;
329 *) ;;
330 esac
331 fi
332 fi
333fi
334
335kdedepend="
336 dev-util/automoc
337 dev-util/pkgconfig
338 !aqua? (
339 >=x11-libs/libXtst-1.1.0
340 x11-proto/xf86vidmodeproto
341 )
342"
343
344kderdepend=""
345
346# all packages needs oxygen icons for basic iconset
347if [[ ${PN} != oxygen-icons ]]; then
348 kderdepend+=" $(add_kdebase_dep oxygen-icons)"
349fi
350
351# add a dependency over kde-l10n if EAPI4 or better is around
352if [[ ${KDEBASE} != "kde-base" && -n ${KDE_LINGUAS} && ${EAPI:-0} != 3 ]]; then
353 for _lingua in ${KDE_LINGUAS}; do
354 # if our package has lignuas, pull in kde-l10n with selected lingua enabled,
355 # but only for selected ones.
356 # this can't be done on one line because if user doesn't use any localisation
357 # then he is probably not interested in kde-l10n at all.
358 kderdepend+="
359 linguas_${_lingua}? ( $(add_kdebase_dep kde-l10n "linguas_${_lingua}(+)") )
237 " 360 "
238 fi 361 done
362 unset _lingua
239fi 363fi
240kdedepend=" 364
241 dev-util/pkgconfig 365kdehandbookdepend="
366 app-text/docbook-xml-dtd:4.2
367 app-text/docbook-xsl-stylesheets
242" 368"
369kdehandbookrdepend="
370 $(add_kdebase_dep kdelibs 'handbook')
371"
372case ${KDE_HANDBOOK} in
373 always)
374 kdedepend+=" ${kdehandbookdepend}"
375 [[ ${PN} != kdelibs ]] && kderdepend+=" ${kdehandbookrdepend}"
376 ;;
377 optional)
378 IUSE+=" +handbook"
379 kdedepend+=" handbook? ( ${kdehandbookdepend} )"
380 [[ ${PN} != kdelibs ]] && kderdepend+=" handbook? ( ${kdehandbookrdepend} )"
381 ;;
382 *) ;;
383esac
384unset kdehandbookdepend kdehandbookrdepend
385
243case ${KDE_REQUIRED} in 386case ${KDE_REQUIRED} in
244 always) 387 always)
245 IUSE+=" aqua" 388 IUSE+=" aqua"
246 COMMONDEPEND+=" ${kdecommondepend}" 389 [[ -n ${kdecommondepend} ]] && COMMONDEPEND+=" ${kdecommondepend}"
247 DEPEND+=" ${kdedepend}" 390 [[ -n ${kdedepend} ]] && DEPEND+=" ${kdedepend}"
391 [[ -n ${kderdepend} ]] && RDEPEND+=" ${kderdepend}"
248 ;; 392 ;;
249 optional) 393 optional)
250 IUSE+=" aqua kde" 394 IUSE+=" aqua kde"
251 COMMONDEPEND+=" kde? ( ${kdecommondepend} )" 395 [[ -n ${kdecommondepend} ]] && COMMONDEPEND+=" kde? ( ${kdecommondepend} )"
252 DEPEND+=" kde? ( ${kdedepend} )" 396 [[ -n ${kdedepend} ]] && DEPEND+=" kde? ( ${kdedepend} )"
397 [[ -n ${kderdepend} ]] && RDEPEND+=" kde? ( ${kderdepend} )"
253 ;; 398 ;;
254 *) ;; 399 *) ;;
255esac 400esac
401
256unset kdecommondepend kdedepend 402unset kdecommondepend kdedepend kderdepend
257 403
258debug-print "${LINENO} ${ECLASS} ${FUNCNAME}: COMMONDEPEND is ${COMMONDEPEND}" 404debug-print "${LINENO} ${ECLASS} ${FUNCNAME}: COMMONDEPEND is ${COMMONDEPEND}"
259debug-print "${LINENO} ${ECLASS} ${FUNCNAME}: DEPEND (only) is ${DEPEND}" 405debug-print "${LINENO} ${ECLASS} ${FUNCNAME}: DEPEND (only) is ${DEPEND}"
260debug-print "${LINENO} ${ECLASS} ${FUNCNAME}: RDEPEND (only) is ${RDEPEND}" 406debug-print "${LINENO} ${ECLASS} ${FUNCNAME}: RDEPEND (only) is ${RDEPEND}"
261 407
262# Accumulate dependencies set by this eclass 408# Accumulate dependencies set by this eclass
263DEPEND+=" ${COMMONDEPEND}" 409DEPEND+=" ${COMMONDEPEND}"
264RDEPEND+=" ${COMMONDEPEND}" 410RDEPEND+=" ${COMMONDEPEND}"
265unset COMMONDEPEND 411unset COMMONDEPEND
266 412
413# Add experimental kdeenablefinal, masked by default
414IUSE+=" kdeenablefinal"
415
267# Fetch section - If the ebuild's category is not 'kde-base' and if it is not a 416# Fetch section - If the ebuild's category is not 'kde-base' and if it is not a
268# koffice ebuild, the URI should be set in the ebuild itself 417# koffice ebuild, the URI should be set in the ebuild itself
269case ${BUILD_TYPE} in 418_calculate_src_uri() {
270 live) 419 debug-print-function ${FUNCNAME} "$@"
271 # Determine branch URL based on live type 420
272 local branch_prefix 421 local _kmname _kmname_pv
422
423 # we calculate URI only for known KDEBASE modules
424 [[ -n ${KDEBASE} ]] || return
425
426 # calculate tarball module name
427 if [[ -n ${KMNAME} ]]; then
428 # fixup kdebase-apps name
273 case ${PV} in 429 case ${KMNAME} in
274 9999*) 430 kdebase-apps)
275 # trunk 431 _kmname="kdebase" ;;
276 branch_prefix="trunk/KDE"
277 ;;
278 *) 432 *)
279 # branch 433 _kmname="${KMNAME}" ;;
280 branch_prefix="branches/KDE/${SLOT}"
281 # @ECLASS-VARIABLE: ESVN_PROJECT_SUFFIX
282 # @DESCRIPTION
283 # Suffix appended to ESVN_PROJECT depending on fetched branch.
284 # Defaults is empty (for -9999 = trunk), and "-${PV}" otherwise.
285 ESVN_PROJECT_SUFFIX="-${PV}"
286 ;;
287 esac 434 esac
288 SRC_URI="" 435 else
289 # @ECLASS-VARIABLE: ESVN_MIRROR 436 _kmname=${PN}
290 # @DESCRIPTION:
291 # This variable allows easy overriding of default kde mirror service
292 # (anonsvn) with anything else you might want to use.
293 ESVN_MIRROR=${ESVN_MIRROR:=svn://anonsvn.kde.org/home/kde}
294 # Split ebuild, or extragear stuff
295 if [[ -n ${KMNAME} ]]; then
296 ESVN_PROJECT="${KMNAME}${ESVN_PROJECT_SUFFIX}"
297 if [[ -z ${KMNOMODULE} ]] && [[ -z ${KMMODULE} ]]; then
298 KMMODULE="${PN}"
299 fi 437 fi
300 # Split kde-base/ ebuilds: (they reside in trunk/KDE) 438 _kmname_pv="${_kmname}-${PV}"
301 case ${KMNAME} in 439 case ${KDEBASE} in
302 kdebase-*) 440 kde-base)
303 ESVN_REPO_URI="${ESVN_MIRROR}/${branch_prefix}/kdebase/${KMNAME#kdebase-}" 441 case ${PV} in
304 ;; 442 4.[456].8[05] | 4.[456].9[023568])
305 kdelibs-*) 443 # Unstable KDE SC releases
306 ESVN_REPO_URI="${ESVN_MIRROR}/${branch_prefix}/kdelibs/${KMNAME#kdelibs-}" 444 SRC_URI="mirror://kde/unstable/${PV}/src/${_kmname_pv}.tar.bz2"
307 ;; 445 # KDEPIM IS SPECIAL
308 kdereview) 446 [[ ${KMNAME} == "kdepim" || ${KMNAME} == "kdepim-runtime" ]] && SRC_URI="mirror://kde/unstable/kdepim/${PV}/${_kmname_pv}.tar.bz2"
309 ESVN_REPO_URI="${ESVN_MIRROR}/trunk/${KMNAME}/${KMMODULE}"
310 ;;
311 kdesupport)
312 ESVN_REPO_URI="${ESVN_MIRROR}/trunk/${KMNAME}/${KMMODULE}"
313 ESVN_PROJECT="${PN}${ESVN_PROJECT_SUFFIX}"
314 ;;
315 kde*)
316 ESVN_REPO_URI="${ESVN_MIRROR}/${branch_prefix}/${KMNAME}"
317 ;;
318 extragear*|playground*)
319 # Unpack them in toplevel dir, so that they won't conflict with kde4-meta
320 # build packages from same svn location.
321 ESVN_REPO_URI="${ESVN_MIRROR}/trunk/${KMNAME}/${KMMODULE}"
322 ESVN_PROJECT="${PN}${ESVN_PROJECT_SUFFIX}"
323 ;;
324 koffice)
325 ESVN_REPO_URI="${ESVN_MIRROR}/trunk/${KMNAME}"
326 ;; 447 ;;
327 *) 448 *)
328 ESVN_REPO_URI="${ESVN_MIRROR}/trunk/${KMNAME}/${KMMODULE}" 449 # Stable KDE SC releases
450 SRC_URI="mirror://kde/stable/${PV}/src/${_kmname_pv}.tar.bz2"
451 # KDEPIM IS SPECIAL
452 [[ ${KMNAME} == "kdepim" || ${KMNAME} == "kdepim-runtime" ]] && SRC_URI="mirror://kde/stable/kdepim-${PV}/src/${_kmname_pv}.tar.bz2"
329 ;; 453 ;;
330 esac 454 esac
331 else 455 ;;
332 # kdelibs, kdepimlibs 456 koffice)
333 ESVN_REPO_URI="${ESVN_MIRROR}/${branch_prefix}/${PN}" 457 case ${PV} in
334 ESVN_PROJECT="${PN}${ESVN_PROJECT_SUFFIX}" 458 2.[1234].[6-9]*) SRC_URI="mirror://kde/unstable/${_kmname_pv}/${_kmname_pv}.tar.bz2" ;;
335 fi 459 *) SRC_URI="mirror://kde/stable/${_kmname_pv}/${_kmname_pv}.tar.bz2" ;;
460 esac
461 ;;
462 kdevelop)
463 SRC_URI="mirror://kde/stable/kdevelop/${KDEVELOP_VERSION}/src/${P}.tar.bz2"
464 ;;
465 esac
466}
467
468_calculate_live_repo() {
469 debug-print-function ${FUNCNAME} "$@"
470
471 SRC_URI=""
472 case ${KDE_SCM} in
473 svn)
474 # Determine branch URL based on live type
475 local branch_prefix
476 case ${PV} in
477 9999*)
478 # trunk
479 branch_prefix="trunk/KDE"
480 ;;
481 *)
482 # branch
483 branch_prefix="branches/KDE/$(get_kde_version)"
484 # @ECLASS-VARIABLE: ESVN_PROJECT_SUFFIX
485 # @DESCRIPTION
486 # Suffix appended to ESVN_PROJECT depending on fetched branch.
487 # Defaults is empty (for -9999 = trunk), and "-${PV}" otherwise.
488 ESVN_PROJECT_SUFFIX="-${PV}"
489 ;;
490 esac
336 # @ECLASS-VARIABLE: ESVN_UP_FREQ 491 # @ECLASS-VARIABLE: ESVN_MIRROR
337 # @DESCRIPTION: 492 # @DESCRIPTION:
338 # This variable is used for specifying the timeout between svn synces 493 # This variable allows easy overriding of default kde mirror service
339 # for kde-base and koffice modules. Does not affect misc apps. 494 # (anonsvn) with anything else you might want to use.
340 # Default value is 1 hour. 495 ESVN_MIRROR=${ESVN_MIRROR:=svn://anonsvn.kde.org/home/kde}
341 [[ ${KDEBASE} = kde-base || ${KDEBASE} = koffice ]] && ESVN_UP_FREQ=${ESVN_UP_FREQ:-1} 496 # Split ebuild, or extragear stuff
342 ;;
343 *)
344 if [[ -n ${KDEBASE} ]]; then
345 if [[ -n ${KMNAME} ]]; then 497 if [[ -n ${KMNAME} ]]; then
498 ESVN_PROJECT="${KMNAME}${ESVN_PROJECT_SUFFIX}"
499 if [[ -z ${KMNOMODULE} ]] && [[ -z ${KMMODULE} ]]; then
500 KMMODULE="${PN}"
501 fi
502 # Split kde-base/ ebuilds: (they reside in trunk/KDE)
346 case ${KMNAME} in 503 case ${KMNAME} in
347 kdebase-apps) 504 kdebase-*)
348 _kmname="kdebase" ;; 505 ESVN_REPO_URI="${ESVN_MIRROR}/${branch_prefix}/kdebase/${KMNAME#kdebase-}"
506 ;;
507 kdelibs-*)
508 ESVN_REPO_URI="${ESVN_MIRROR}/${branch_prefix}/kdelibs/${KMNAME#kdelibs-}"
509 ;;
510 kdereview*)
511 ESVN_REPO_URI="${ESVN_MIRROR}/trunk/${KMNAME}/${KMMODULE}"
512 ;;
513 kdesupport)
514 ESVN_REPO_URI="${ESVN_MIRROR}/trunk/${KMNAME}/${KMMODULE}"
515 ESVN_PROJECT="${PN}${ESVN_PROJECT_SUFFIX}"
516 ;;
517 kde*)
518 ESVN_REPO_URI="${ESVN_MIRROR}/${branch_prefix}/${KMNAME}"
519 ;;
520 extragear*|playground*)
521 # Unpack them in toplevel dir, so that they won't conflict with kde4-meta
522 # build packages from same svn location.
523 ESVN_REPO_URI="${ESVN_MIRROR}/trunk/${KMNAME}/${KMMODULE}"
524 ESVN_PROJECT="${PN}${ESVN_PROJECT_SUFFIX}"
525 ;;
526 koffice)
527 ESVN_REPO_URI="${ESVN_MIRROR}/trunk/${KMNAME}"
528 ;;
349 *) 529 *)
350 _kmname="${KMNAME}" ;; 530 ESVN_REPO_URI="${ESVN_MIRROR}/trunk/${KMNAME}/${KMMODULE}"
531 ;;
351 esac 532 esac
533 else
534 # kdelibs, kdepimlibs
535 ESVN_REPO_URI="${ESVN_MIRROR}/${branch_prefix}/${PN}"
536 ESVN_PROJECT="${PN}${ESVN_PROJECT_SUFFIX}"
537 fi
538 # @ECLASS-VARIABLE: ESVN_UP_FREQ
539 # @DESCRIPTION:
540 # This variable is used for specifying the timeout between svn synces
541 # for kde-base and koffice modules. Does not affect misc apps.
542 # Default value is 1 hour.
543 [[ ${KDEBASE} = kde-base || ${KDEBASE} = koffice ]] && ESVN_UP_FREQ=${ESVN_UP_FREQ:-1}
544 ;;
545 git)
546 local _kmname
547 # @ECLASS-VARIABLE: EGIT_MIRROR
548 # @DESCRIPTION:
549 # This variable allows easy overriding of default kde mirror service
550 # (anongit) with anything else you might want to use.
551 EGIT_MIRROR=${EGIT_MIRROR:=git://anongit.kde.org}
552
553 # @ECLASS-VARIABLE: EGIT_REPONAME
554 # @DESCRIPTION:
555 # This variable allows overriding of default repository
556 # name. Specify only if this differ from PN and KMNAME.
557 if [[ -n ${EGIT_REPONAME} ]]; then
558 # the repository and kmname different
559 _kmname=${EGIT_REPONAME}
560 elif [[ -n ${KMNAME} ]]; then
561 _kmname=${KMNAME}
352 else 562 else
353 _kmname=${PN} 563 _kmname=${PN}
354 fi 564 fi
355 _kmname_pv="${_kmname}-${PV}" 565
356 case ${KDEBASE} in 566 # default branching
357 kde-base)
358 case ${PV} in 567 case ${PV} in
359 4.3.85 | 4.3.9[0568]) 568 9999*) ;;
360 # block for normally packed unstable releases 569 *)
361 SRC_URI="mirror://kde/unstable/${PV}/src/${_kmname_pv}.tar.bz2" ;; 570 # set EGIT_BRANCH and EGIT_COMMIT to $(get_kde_version)
362 4.3.[6-9]*) 571 case ${_kmname} in
363 SRC_URI="http://dev.gentooexperimental.org/~alexxy/kde/${PV}/${_kmname_pv}.tar.lzma" ;; 572 kdeplasma-addons | kdepim | kdepim-runtime | kdepimlibs | okular)
364 *) SRC_URI="mirror://kde/stable/${PV}/src/${_kmname_pv}.tar.bz2" ;; 573 EGIT_BRANCH="$(get_kde_version)"
574 ;;
575 kdeedu)
576 EGIT_BRANCH="$(get_kde_version)"
577 ;;
578 marble)
579 EGIT_BRANCH="kde-$(get_kde_version)"
580 ;;
581 *) EGIT_BRANCH="KDE/$(get_kde_version)" ;;
365 esac 582 esac
366 ;; 583 ;;
367 koffice)
368 case ${PV} in
369 2.0.[6-9]*) SRC_URI="mirror://kde/unstable/${_kmname_pv}/src/${_kmname_pv}.tar.bz2" ;;
370 *) SRC_URI="mirror://kde/stable/${_kmname_pv}/${_kmname_pv}.tar.bz2" ;;
371 esac
372 esac 584 esac
373 unset _kmname _kmname_pv 585
374 fi 586 # default repo uri
587 case ${_kmname} in
588 kdeedu)
589 EGIT_REPO_URI="${EGIT_MIRROR}/${PN}"
590 ;;
591 *)
592 EGIT_REPO_URI="${EGIT_MIRROR}/${_kmname}"
593 esac
594
595 debug-print "${FUNCNAME}: Repository: ${EGIT_REPO_URI}"
596 debug-print "${FUNCNAME}: Branch: ${EGIT_BRANCH}"
375 ;; 597 ;;
598 esac
599}
600
601case ${BUILD_TYPE} in
602 live) _calculate_live_repo ;;
603 *) _calculate_src_uri ;;
376esac 604esac
377 605
378debug-print "${LINENO} ${ECLASS} ${FUNCNAME}: SRC_URI is ${SRC_URI}" 606debug-print "${LINENO} ${ECLASS} ${FUNCNAME}: SRC_URI is ${SRC_URI}"
379 607
380# @ECLASS-VARIABLE: PREFIX 608# @ECLASS-VARIABLE: PREFIX
383# kde-base packages go into KDE4 installation directory (KDEDIR) by default. 611# kde-base packages go into KDE4 installation directory (KDEDIR) by default.
384# No matter the PREFIX, package will be built against KDE installed in KDEDIR. 612# No matter the PREFIX, package will be built against KDE installed in KDEDIR.
385 613
386# @FUNCTION: kde4-base_pkg_setup 614# @FUNCTION: kde4-base_pkg_setup
387# @DESCRIPTION: 615# @DESCRIPTION:
388# Do the basic kdeprefix KDEDIR settings and determine with which kde should 616# Do the basic KDEDIR settings and determine with which kde should
389# optional applications link 617# optional applications link
390kde4-base_pkg_setup() { 618kde4-base_pkg_setup() {
391 debug-print-function ${FUNCNAME} "$@" 619 debug-print-function ${FUNCNAME} "$@"
392 620
393 # Prefix compat: 621 if has kdeprefix ${IUSE//+} && use kdeprefix; then
394 use prefix || EROOT=${ROOT} 622 eerror "Sorry, kdeprefix support has been removed."
395 # Append missing trailing slash character 623 eerror "Please remove kdeprefix from your USE variable."
396 [[ ${EROOT} = */ ]] || EROOT+="/" 624 die "kdeprefix support has been removed"
625 fi
397 626
398 # QA ebuilds 627 if [[ ${CATEGORY}/${PN} != kde-base/kdelibs && ${CATEGORY}/${PN} != kde-base/kde-env ]] && \
399 [[ -z ${KDE_MINIMAL_VALID} ]] && ewarn "QA Notice: ignoring invalid KDE_MINIMAL (defaulting to ${KDE_MINIMAL})." 628 { [[ ${KDE_REQUIRED} == always ]] || { [[ ${KDE_REQUIRED} == optional ]] && use kde; }; } && \
629 has_version kde-base/kdelibs[kdeprefix]; then
630 eerror "Sorry, kdeprefix support has been removed."
631 eerror "Please rebuild kdelibs without kdeprefix support."
632 die "kdeprefix support has been removed"
633 fi
400 634
401 # Don't set KDEHOME during compilation, it will cause access violations 635 # Don't set KDEHOME during compilation, it will cause access violations
402 unset KDEHOME 636 unset KDEHOME
403 637
404 if [[ ${KDEBASE} = kde-base ]]; then 638 # Check if gcc compiler is fresh enough.
405 if use kdeprefix; then 639 # In theory should be in pkg_pretend but we check it only for kdelibs there
406 KDEDIR="${EROOT}usr/kde/${_kdedir}" 640 # and for others we do just quick scan in pkg_setup because pkg_pretend
407 else 641 # executions consume quite some time.
408 KDEDIR="${EROOT}usr" 642 [[ $(gcc-major-version) -lt 4 ]] || \
409 fi 643 ( [[ $(gcc-major-version) -eq 4 && $(gcc-minor-version) -le 3 ]] ) \
410 PREFIX="${PREFIX:-${KDEDIR}}" 644 && die "Sorry, but gcc-4.3 and earlier wont work for KDE (see bug 354837)."
411 else 645
412 # Determine KDEDIR by loooking for the closest match with KDE_MINIMAL
413 KDEDIR= 646 KDEDIR=/usr
414 local kde_minimal_met 647 : ${PREFIX:=/usr}
415 for slot in ${KDE_SLOTS[@]} ${KDE_LIVE_SLOTS[@]}; do 648 EKDEDIR=${EPREFIX}/usr
416 [[ -z ${kde_minimal_met} ]] && [[ ${slot} = ${KDE_MINIMAL} ]] && kde_minimal_met=1
417 if [[ -n ${kde_minimal_met} ]] && has_version "kde-base/kdelibs:${slot}"; then
418 if has_version "kde-base/kdelibs:${slot}[kdeprefix]"; then
419 KDEDIR="${EROOT}usr/kde/${slot}"
420 else
421 KDEDIR="${EROOT}usr"
422 fi
423 break;
424 fi
425 done
426 unset slot
427 649
428 # Bail out if kdelibs required but not found
429 if [[ ${KDE_REQUIRED} = always ]] || { [[ ${KDE_REQUIRED} = optional ]] && use kde; }; then
430 [[ -z ${KDEDIR} ]] && die "Failed to determine KDEDIR!"
431 else
432 [[ -z ${KDEDIR} ]] && KDEDIR="${EROOT}usr"
433 fi
434
435 PREFIX="${PREFIX:-${EROOT}usr}"
436 fi
437 # Point pkg-config path to KDE *.pc files 650 # Point pkg-config path to KDE *.pc files
438 export PKG_CONFIG_PATH="${KDEDIR}/$(get_libdir)/pkgconfig${PKG_CONFIG_PATH:+:${PKG_CONFIG_PATH}}" 651 export PKG_CONFIG_PATH="${EKDEDIR}/$(get_libdir)/pkgconfig${PKG_CONFIG_PATH:+:${PKG_CONFIG_PATH}}"
439 # Point to correct QT plugins path 652 # Point to correct QT plugins path
440 QT_PLUGIN_PATH="${KDEDIR}/$(get_libdir)/kde4/plugins/" 653 QT_PLUGIN_PATH="${EKDEDIR}/$(get_libdir)/kde4/plugins/"
441 654
442 # Fix XDG collision with sandbox 655 # Fix XDG collision with sandbox
443 export XDG_CONFIG_HOME="${T}" 656 export XDG_CONFIG_HOME="${T}"
444 # Not needed anymore
445 unset _kdedir
446} 657}
447 658
448# @FUNCTION: kde4-base_src_unpack 659# @FUNCTION: kde4-base_src_unpack
449# @DESCRIPTION: 660# @DESCRIPTION:
450# This function unpacks the source tarballs for KDE4 applications. 661# This function unpacks the source tarballs for KDE4 applications.
451kde4-base_src_unpack() { 662kde4-base_src_unpack() {
452 debug-print-function ${FUNCNAME} "$@" 663 debug-print-function ${FUNCNAME} "$@"
453 664
454 if [[ ${BUILD_TYPE} = live ]]; then 665 if [[ ${BUILD_TYPE} = live ]]; then
666 case ${KDE_SCM} in
667 svn)
455 migrate_store_dir 668 migrate_store_dir
456 subversion_src_unpack 669 subversion_src_unpack
670 ;;
671 git)
672 git-2_src_unpack
673 ;;
674 esac
457 else 675 else
458 base_src_unpack 676 unpack ${A}
459 fi 677 fi
460} 678}
461 679
462# @FUNCTION: kde4-base_src_prepare 680# @FUNCTION: kde4-base_src_prepare
463# @DESCRIPTION: 681# @DESCRIPTION:
466# enable_selected_linguas() and enable_selected_doc_linguas() 684# enable_selected_linguas() and enable_selected_doc_linguas()
467# in kde4-functions.eclass(5) for further details. 685# in kde4-functions.eclass(5) for further details.
468kde4-base_src_prepare() { 686kde4-base_src_prepare() {
469 debug-print-function ${FUNCNAME} "$@" 687 debug-print-function ${FUNCNAME} "$@"
470 688
689 # enable handbook and linguas only when not using live ebuild
690
471 # Only enable selected languages, used for KDE extragear apps. 691 # Only enable selected languages, used for KDE extragear apps.
472 if [[ -n ${KDE_LINGUAS} ]]; then 692 if [[ -n ${KDE_LINGUAS} ]]; then
473 enable_selected_linguas 693 enable_selected_linguas
474 fi 694 fi
475 695
476 # Enable/disable handbooks for kde4-base packages 696 # Enable/disable handbooks for kde4-base packages
477 # kde-l10n inherits kde4-base but is metpackage, so no check for doc 697 # kde-l10n inherits kde4-base but is metpackage, so no check for doc
478 # kdelibs inherits kde4-base but handle installing the handbook itself 698 # kdelibs inherits kde4-base but handle installing the handbook itself
479 if ! has kde4-meta ${INHERITED}; then 699 if ! has kde4-meta ${INHERITED} && has handbook ${IUSE//+}; then
480 has handbook ${IUSE//+} && [[ ${PN} != kde-l10n ]] && [[ ${PN} != kdelibs ]] && enable_selected_doc_linguas 700 if [[ ${KDEBASE} == kde-base ]]; then
701 if [[ ${PN} != kde-l10n && ${PN} != kdepim-l10n && ${PN} != kdelibs ]] && use !handbook; then
702 # documentation in kde4-functions
703 : ${KDE_DOC_DIRS:=doc}
704 local dir
705 for dir in ${KDE_DOC_DIRS}; do
706 sed -e "\!^[[:space:]]*add_subdirectory[[:space:]]*([[:space:]]*${dir}[[:space:]]*)!s/^/#DONOTCOMPILE /" \
707 -e "\!^[[:space:]]*ADD_SUBDIRECTORY[[:space:]]*([[:space:]]*${dir}[[:space:]]*)!s/^/#DONOTCOMPILE /" \
708 -e "\!^[[:space:]]*macro_optional_add_subdirectory[[:space:]]*([[:space:]]*${dir}[[:space:]]*)!s/^/#DONOTCOMPILE /" \
709 -e "\!^[[:space:]]*MACRO_OPTIONAL_ADD_SUBDIRECTORY[[:space:]]*([[:space:]]*${dir}[[:space:]]*)!s/^/#DONOTCOMPILE /" \
710 -i CMakeLists.txt || die "failed to comment out handbook"
711 done
712 fi
713 else
714 enable_selected_doc_linguas
481 fi 715 fi
716 fi
482 717
483 [[ ${BUILD_TYPE} = live ]] && subversion_src_prepare 718 # SCM bootstrap
719 if [[ ${BUILD_TYPE} = live ]]; then
720 case ${KDE_SCM} in
721 svn) subversion_src_prepare ;;
722 esac
723 fi
724
725 # Apply patches
484 base_src_prepare 726 base_src_prepare
485 727
486 # Save library dependencies 728 # Save library dependencies
487 if [[ -n ${KMSAVELIBS} ]] ; then 729 if [[ -n ${KMSAVELIBS} ]] ; then
488 save_library_dependencies 730 save_library_dependencies
490 732
491 # Inject library dependencies 733 # Inject library dependencies
492 if [[ -n ${KMLOADLIBS} ]] ; then 734 if [[ -n ${KMLOADLIBS} ]] ; then
493 load_library_dependencies 735 load_library_dependencies
494 fi 736 fi
737
738 # Replace KDE4Workspace library targets
739 find "${S}" -name CMakeLists.txt \
740 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_TASKMANAGER_(LIBRARY|LIBS)\}/taskmanager/g' {} + \
741 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_KWORKSPACE_(LIBRARY|LIBS)\}/kworkspace/g' {} + \
742 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_SOLIDCONTROLIFACES_(LIBRARY|LIBS)\}/solidcontrolifaces/g' {} + \
743 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_SOLIDCONTROL_(LIBRARY|LIBS)\}/solidcontrol/g' {} + \
744 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_PROCESSUI_(LIBRARY|LIBS)\}/processui/g' {} + \
745 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_LSOFUI_(LIBRARY|LIBS)\}/lsofui/g' {} + \
746 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_PLASMACLOCK_(LIBRARY|LIBS)\}/plasmaclock/g' {} + \
747 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_NEPOMUKQUERYCLIENT_(LIBRARY|LIBS)\}/nepomukqueryclient/g' {} + \
748 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_NEPOMUKQUERY_(LIBRARY|LIBS)\}/nepomukquery/g' {} + \
749 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_KSCREENSAVER_(LIBRARY|LIBS)\}/kscreensaver/g' {} + \
750 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_WEATHERION_(LIBRARY|LIBS)\}/weather_ion/g' {} + \
751 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_KWINEFFECTS_(LIBRARY|LIBS)\}/kwineffects/g' {} + \
752 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_KDECORATIONS_(LIBRARY|LIBS)\}/kdecorations/g' {} + \
753 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_KSGRD_(LIBRARY|LIBS)\}/ksgrd/g' {} + \
754 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_KEPHAL_(LIBRARY|LIBS)\}/kephal/g' {} + \
755 || die 'failed to replace KDE4Workspace library targets'
756
757 # Hack for manuals relying on outdated DTD, only outside kde-base/koffice/...
758 if [[ -z ${KDEBASE} ]]; then
759 find "${S}" -name "*.docbook" \
760 -exec sed -i -r \
761 -e 's:-//KDE//DTD DocBook XML V4\.1(\..)?-Based Variant V1\.[01]//EN:-//KDE//DTD DocBook XML V4.2-Based Variant V1.1//EN:g' {} + \
762 || die 'failed to fix DocBook variant version'
763 fi
495} 764}
496 765
497# @FUNCTION: kde4-base_src_configure 766# @FUNCTION: kde4-base_src_configure
498# @DESCRIPTION: 767# @DESCRIPTION:
499# Function for configuring the build of KDE4 applications. 768# Function for configuring the build of KDE4 applications.
500kde4-base_src_configure() { 769kde4-base_src_configure() {
501 debug-print-function ${FUNCNAME} "$@" 770 debug-print-function ${FUNCNAME} "$@"
502 771
772 # Build tests in src_test only, where we override this value
773 local cmakeargs=(-DKDE4_BUILD_TESTS=OFF)
774
775 if has kdeenablefinal ${IUSE//+} && use kdeenablefinal; then
776 cmakeargs+=(-DKDE4_ENABLE_FINAL=ON)
777 fi
778
779 if has debug ${IUSE//+} && use debug; then
780 # Set "real" debug mode
781 CMAKE_BUILD_TYPE="Debugfull"
782 else
503 # Handle common release builds 783 # Handle common release builds
504 if ! has debug ${IUSE//+} || ! use debug; then
505 append-cppflags -DQT_NO_DEBUG 784 append-cppflags -DQT_NO_DEBUG
506 fi 785 fi
507 786
508 # Build tests in src_test only, where we override this value
509 local cmakeargs="-DKDE4_BUILD_TESTS=OFF"
510
511 # set "real" debug mode
512 if has debug ${IUSE//+} && use debug; then
513 CMAKE_BUILD_TYPE="Debugfull"
514 fi
515
516 # Set distribution name 787 # Set distribution name
517 [[ ${PN} = kdelibs ]] && cmakeargs+=" -DKDE_DISTRIBUTION_TEXT=Gentoo" 788 [[ ${PN} = kdelibs ]] && cmakeargs+=(-DKDE_DISTRIBUTION_TEXT=Gentoo)
518 789
519 # Here we set the install prefix 790 # Here we set the install prefix
520 cmakeargs+=" -DCMAKE_INSTALL_PREFIX=${PREFIX}" 791 tc-is-cross-compiler || cmakeargs+=(-DCMAKE_INSTALL_PREFIX="${EPREFIX}${PREFIX}")
521 792
522 # Use colors 793 # Use colors
523 QTEST_COLORED=1 794 QTEST_COLORED=1
524 795
525 # Shadow existing /usr installations 796 # Shadow existing /usr installations
526 unset KDEDIRS 797 unset KDEDIRS
527 798
528 # Handle kdeprefix-ed KDE 799 #qmake -query QT_INSTALL_LIBS unavailable when cross-compiling
529 if [[ ${KDEDIR} != "${EROOT}usr" ]]; then 800 tc-is-cross-compiler && cmakeargs+=(-DQT_LIBRARY_DIR=${ROOT}/usr/$(get_libdir)/qt4)
530 # Override some environment variables - only when kdeprefix is different, 801 #kde-config -path data unavailable when cross-compiling
531 # to not break ccache/distcc 802 tc-is-cross-compiler && cmakeargs+=(-DKDE4_DATA_DIR=${ROOT}/usr/share/apps/)
532 PATH="${KDEDIR}/bin:${PATH}"
533 LDPATH="${KDEDIR}/$(get_libdir):${LDPATH}"
534 803
535 # Append full RPATH
536 cmakeargs+=" -DCMAKE_SKIP_RPATH=OFF"
537
538 # Set cmake prefixes to allow buildsystem to locate valid KDE installation
539 # when more are present
540 cmakeargs+=" -DCMAKE_SYSTEM_PREFIX_PATH=${KDEDIR}"
541 fi
542
543 # Handle kdeprefix in application itself
544 if ! has kdeprefix ${IUSE//+} || ! use kdeprefix; then
545 # If prefix is /usr, sysconf needs to be /etc, not /usr/etc 804 # sysconf needs to be /etc, not /usr/etc
546 cmakeargs+=" -DSYSCONF_INSTALL_DIR=${EROOT}etc" 805 cmakeargs+=(-DSYSCONF_INSTALL_DIR="${EPREFIX}"/etc)
547 fi
548 806
807 if [[ $(declare -p mycmakeargs 2>&-) != "declare -a mycmakeargs="* ]]; then
808 mycmakeargs=(${mycmakeargs})
809 fi
810
549 mycmakeargs="${cmakeargs} ${mycmakeargs}" 811 mycmakeargs=("${cmakeargs[@]}" "${mycmakeargs[@]}")
550 812
551 cmake-utils_src_configure 813 cmake-utils_src_configure
552} 814}
553 815
554# @FUNCTION: kde4-base_src_compile 816# @FUNCTION: kde4-base_src_compile
565# Function for testing KDE4 applications. 827# Function for testing KDE4 applications.
566kde4-base_src_test() { 828kde4-base_src_test() {
567 debug-print-function ${FUNCNAME} "$@" 829 debug-print-function ${FUNCNAME} "$@"
568 830
569 # Override this value, set in kde4-base_src_configure() 831 # Override this value, set in kde4-base_src_configure()
570 mycmakeargs+=" -DKDE4_BUILD_TESTS=ON" 832 mycmakeargs+=(-DKDE4_BUILD_TESTS=ON)
571 cmake-utils_src_configure 833 cmake-utils_src_configure
572 kde4-base_src_compile 834 kde4-base_src_compile
573 835
836 # When run as normal user during ebuild development with the ebuild command, the
837 # kde tests tend to access the session DBUS. This however is not possible in a real
838 # emerge or on the tinderbox.
839 # > make sure it does not happen, so bad tests can be recognized and disabled
840 unset DBUS_SESSION_BUS_ADDRESS
841
842 if [[ ${VIRTUALX_REQUIRED} == always || ${VIRTUALX_REQUIRED} == test ]]; then
843 # check for sanity if anyone already redefined VIRTUALX_COMMAND from the default
844 if [[ ${VIRTUALX_COMMAND} != emake ]]; then
845 # surprise- we are already INSIDE virtualmake!!!
846 debug-print "QA Notice: This version of kde4-base.eclass includes the virtualx functionality."
847 debug-print " You may NOT set VIRTUALX_COMMAND or call virtualmake from the ebuild."
848 debug-print " Setting VIRTUALX_REQUIRED is completely sufficient. See the"
849 debug-print " kde4-base.eclass docs for details... Applying workaround."
850 cmake-utils_src_test
851 else
852 VIRTUALX_COMMAND="cmake-utils_src_test" virtualmake
853 fi
854 else
574 cmake-utils_src_test 855 cmake-utils_src_test
856 fi
575} 857}
576 858
577# @FUNCTION: kde4-base_src_install 859# @FUNCTION: kde4-base_src_install
578# @DESCRIPTION: 860# @DESCRIPTION:
579# Function for installing KDE4 applications. 861# Function for installing KDE4 applications.
582 864
583 if [[ -n ${KMSAVELIBS} ]] ; then 865 if [[ -n ${KMSAVELIBS} ]] ; then
584 install_library_dependencies 866 install_library_dependencies
585 fi 867 fi
586 868
587 kde4-base_src_make_doc 869 # Install common documentation of KDE4 applications
870 local doc
871 if ! has kde4-meta ${INHERITED}; then
872 for doc in "${S}"/{AUTHORS,CHANGELOG,ChangeLog*,README*,NEWS,TODO,HACKING}; do
873 [[ -f ${doc} && -s ${doc} ]] && dodoc "${doc}"
874 done
875 for doc in "${S}"/*/{AUTHORS,CHANGELOG,ChangeLog*,README*,NEWS,TODO,HACKING}; do
876 [[ -f ${doc} && -s ${doc} ]] && newdoc "${doc}" "$(basename $(dirname ${doc})).$(basename ${doc})"
877 done
878 fi
879
588 cmake-utils_src_install 880 cmake-utils_src_install
589}
590 881
591# @FUNCTION: kde4-base_src_make_doc 882 # In EAPI 4+, we don't want ${PREFIX}/share/doc/HTML to be compressed,
592# @DESCRIPTION: 883 # because then khelpcenter can't find the docs
593# Function for installing the documentation of KDE4 applications. 884 [[ ${EAPI:-0} != 3 && -d ${ED}/${PREFIX}/share/doc/HTML ]] &&
594kde4-base_src_make_doc() { 885 docompress -x ${PREFIX}/share/doc/HTML
595 debug-print-function ${FUNCNAME} "$@" 886}
596 887
597 local doc 888# @FUNCTION: kde4-base_pkg_preinst
598 for doc in AUTHORS ChangeLog* README* NEWS TODO; do 889# @DESCRIPTION:
599 [[ -s ${doc} ]] && dodoc ${doc} 890# Function storing icon caches
600 done 891kde4-base_pkg_preinst() {
892 debug-print-function ${FUNCNAME} "$@"
601 893
602 if [[ -z ${KMNAME} ]]; then 894 gnome2_icon_savelist
603 for doc in {apps,runtime,workspace,.}/*/{AUTHORS,README*}; do
604 if [[ -s ${doc} ]]; then
605 local doc_complete=${doc}
606 doc="${doc#*/}"
607 newdoc "$doc_complete" "${doc%/*}.${doc##*/}"
608 fi
609 done
610 fi
611
612 if [[ -n ${KDEBASE} ]] && [[ -d "${D}${EROOT}usr/share/doc/${PF}" ]]; then
613 # work around bug #97196
614 dodir /usr/share/doc/KDE4 && \
615 cp -r "${D}${EROOT}usr/share/doc/${PF}" "${D}${EROOT}usr/share/doc/KDE4/" || \
616 die "Failed to move docs to KDE4/."
617 rm -rf "${D}${EROOT}usr/share/doc/${PF}"
618 fi
619} 895}
620 896
621# @FUNCTION: kde4-base_pkg_postinst 897# @FUNCTION: kde4-base_pkg_postinst
622# @DESCRIPTION: 898# @DESCRIPTION:
623# Function to rebuild the KDE System Configuration Cache after an application has been installed. 899# Function to rebuild the KDE System Configuration Cache after an application has been installed.
624kde4-base_pkg_postinst() { 900kde4-base_pkg_postinst() {
625 debug-print-function ${FUNCNAME} "$@" 901 debug-print-function ${FUNCNAME} "$@"
626 902
903 gnome2_icon_cache_update
904 fdo-mime_desktop_database_update
905 fdo-mime_mime_database_update
627 buildsycoca 906 buildsycoca
628 907
629 if [[ ${BUILD_TYPE} = live ]] && [[ -z ${I_KNOW_WHAT_I_AM_DOING} ]]; then 908 if [[ -z ${I_KNOW_WHAT_I_AM_DOING} ]]; then
909 if has kdeenablefinal ${IUSE//+} && use kdeenablefinal; then
630 echo 910 echo
631 einfo "WARNING! This is an experimental live ebuild of ${CATEGORY}/${PN}"
632 einfo "Use it at your own risk."
633 einfo "Do _NOT_ file bugs at bugs.gentoo.org because of this ebuild!"
634 echo
635 elif [[ ${BUILD_TYPE} != live ]] && [[ -z ${I_KNOW_WHAT_I_AM_DOING} ]] && has kdeprefix ${IUSE//+} && use kdeprefix; then
636 # warning about kdeprefix for non-live users
637 echo
638 ewarn "WARNING! You have the kdeprefix useflag enabled." 911 ewarn "WARNING! you have kdeenable final useflag enabled."
639 ewarn "This setting is strongly discouraged and might lead to potential trouble" 912 ewarn "This useflag needs to be enabled on ALL kde using packages and"
640 ewarn "with KDE update strategies." 913 ewarn "is known to cause issues."
641 ewarn "You are using this setup at your own risk and the kde team does not" 914 ewarn "You are using this setup at your own risk and the kde team does not"
642 ewarn "take responsibilities for dead kittens." 915 ewarn "take responsibilities for dead kittens."
643 echo 916 echo
917 fi
918 if [[ ${BUILD_TYPE} = live ]]; then
919 echo
920 einfo "WARNING! This is an experimental live ebuild of ${CATEGORY}/${PN}"
921 einfo "Use it at your own risk."
922 einfo "Do _NOT_ file bugs at bugs.gentoo.org because of this ebuild!"
923 echo
924 fi
925 # for all 3rd party soft tell user that he SHOULD install kdebase-startkde or kdebase-runtime-meta
926 if [[ ${KDEBASE} != kde-base ]] && \
927 ! has_version 'kde-base/kdebase-runtime-meta' && \
928 ! has_version 'kde-base/kdebase-startkde'; then
929 if [[ ${KDE_REQUIRED} == always ]] || ( [[ ${KDE_REQUIRED} == optional ]] && use kde ); then
930 echo
931 ewarn "WARNING! Your system configuration contains neither \"kde-base/kdebase-runtime-meta\""
932 ewarn "nor \"kde-base/kdebase-startkde\". You need one of above."
933 ewarn "With this setting you are unsupported by KDE team."
934 ewarn "All missing features you report for misc packages will be probably ignored or closed as INVALID."
935 fi
936 fi
644 fi 937 fi
645} 938}
646 939
647# @FUNCTION: kde4-base_pkg_postrm 940# @FUNCTION: kde4-base_pkg_postrm
648# @DESCRIPTION: 941# @DESCRIPTION:
649# Function to rebuild the KDE System Configuration Cache after an application has been removed. 942# Function to rebuild the KDE System Configuration Cache after an application has been removed.
650kde4-base_pkg_postrm() { 943kde4-base_pkg_postrm() {
651 debug-print-function ${FUNCNAME} "$@" 944 debug-print-function ${FUNCNAME} "$@"
652 945
946 gnome2_icon_cache_update
947 fdo-mime_desktop_database_update
948 fdo-mime_mime_database_update
653 buildsycoca 949 buildsycoca
654} 950}

Legend:
Removed from v.1.53  
changed lines
  Added in v.1.99

  ViewVC Help
Powered by ViewVC 1.1.20